# -*- coding: utf-8 -*-
# In[1]:

#import matplotlib.pyplot as plt
import numpy as np
import cPickle as pickle
#import matplotlib.colors as mcolors
import xarray as xr
import xgcm
import sys
#from jmkfigure import *
#plt.style.use('ggplot')
def plotSlice(ax,D,var,vlim=0.1,cmap='RdBu_r'):
    pcm=ax.pcolormesh(D['x'],D['z'],D[var],vmin=-vlim,vmax=vlim,cmap=cmap)
    return pcm


# In[ ]:

def _append_to_name(array, append):
    try:
        return array.name + "_" + append
    except TypeError:
        return append
    

def diffArray(array,dim,newdim):
    da=array.diff(dim=dim)
    key = newdim.keys()[0]
    da=da.rename({dim:key})
    da[key].data = newdim[key]
    return da

def avgArray(array,dim,newdim):
    da=array.isel(**{dim:slice(None,-1)})
    da+=array.isel(**{dim:slice(1,None)}).data
    da = 0.5*da
    key = newdim.keys()[0]
    da=da.rename({dim:key})
    da[key].data = newdim[key]
    return da.rename(_append_to_name(array,'avg_p1_to_p'))

# In[25]:


if len(sys.argv)>2:
    pre = sys.argv[1]
    U0  = float(sys.argv[2])
else:
    sys.exit('Need to specify the prefix directory')

print pre
#pre = 'lee3dfull01'

#pre = 'lee3dfullSecOr'
dss=[0,0]
dss[1] = xr.open_dataset('../results/'+pre+'/_Model/input/ds0000071280.nc')
dss[0] = xr.open_dataset('../results/'+pre+'/_Model/input/ds0000070560.nc')

# In[27]:

N0=1e-3
g=9.8
alpha = 2e-4
dz=10.
T0 = 28-np.cumsum(N0**2/g/alpha*dz*np.ones(400))


# PE is a pain.  PE = (1/rho0) \rho' g z dz  (m^2/s^2)

# In[28]:

for n in range(2):
    dss[n]['T0']=(('Z'),T0)
    


# In[29]:

for n in range(2):
    indy = np.where(dss[n]['dyG'][:,0] ==100.)[0][2:]
    iny = dss[n]['Y'][indy]
    indx = np.where(dss[n]['dxG'][:,0] ==100.)[0][2:]
    indx = np.where(np.abs(dss[n]['X']-np.mean(dss[n]['X']))<34e3)[0]
    inx = dss[n]['X'][indx]
    inxp1 = dss[n]['Xp1'][np.hstack((indx[0]-1,indx))]
    dss[n]= dss[n].isel(time=0,Y=indy,Yp1=np.hstack((indy[0]-1,indy)),
                X=indx,Xp1=np.hstack((indx[0]-1,indx)))



# In[33]:

def intxCyC(data,ds):
    dx = ds['dxG'].isel(Yp1=slice(1,None)).data
    dy = ds['dyG'].isel(Xp1=slice(1,None)).data
    return (data*ds['HFacC']*dx*dy).sum(dim='X').sum(dim='Y')
def mapZtoZl(ds,var):
    P = ds[var]*0.
    P=P.rename({'Z':'Zl'})
    P['Zl'].data = ds['Zl'].data

    P.data[1:,:,:] = (ds[var].isel(Z=slice(0,-1)).data+ds[var].isel(Z=slice(1,None)).data)*0.5
    P.data[0,:,:]=0.5*(ds[var].isel(Z=0).data)
    return P
def intxCyCInner(data,ds,hfac=None):
    if hfac is None:
        hfac = ds['HFacC']
    dx = ds['dxG'].isel(Yp1=slice(1,None)).data
    dy = ds['dyG'].isel(Xp1=slice(1,None)).data
    if np.ndim(data)==4:
        return (data[:,:,1:-1,1:-1]*hfac[:,1:-1,1:-1]*dx[1:-1,1:-1]*dy[1:-1,1:-1]).sum(dim='X').sum(dim='Y')
    elif np.ndim(data)==3:
        return (data[:,1:-1,1:-1]*hfac[:,1:-1,1:-1]*dx[1:-1,1:-1]*dy[1:-1,1:-1]).sum(dim='X').sum(dim='Y')
        


# In[34]:

def _get_coords_from_dims(self, dims, replace=None):
    """Utility function for quickly fetching coordinates from parent
    dataset.
    """
    dims = list(dims)
    if replace:
        for k in replace:
            dims[dims.index(k)] = replace[k]
    return {dim: self.ds[dim] for dim in dims}, dims


# In[35]:

# get kinetic energy at center of grid cells
#
# integration is at ind = 1 to ind = -1.  This allows us to get data from the U,V cells at those 
# points.
#
# What we really should have done was actualy subset P one larger than U (the opposite of the
# usual).  

energy=[[],[]]
for n in range(2):
    energy[n] = xr.Dataset()
    a = slice(None,-1)
    b = slice(1,None)

    energy[n]['KE'] = 0.*dss[n]['T0']
    energy[n]['KE'] += intxCyCInner( 0.5*(0.5*dss[n]['U'].isel(Xp1=a)**2).data,dss[n])
    energy[n]['KE'] += intxCyCInner(0.5*(0.5*dss[n]['U'].isel(Xp1=b)**2).data,dss[n])
    energy[n]['KE'] += intxCyCInner(0.5*(0.5*dss[n]['V'].isel(Yp1=a)**2).data,dss[n])
    energy[n]['KE'] += intxCyCInner(0.5*(0.5*dss[n]['V'].isel(Yp1=b)**2).data,dss[n])
    #energy['KE'][slice(None,-1)] += intxCyCInner(0.5*(0.5*ds['W'].isel(Zl=a)**2).data,ds)
    #energy['KE'][slice(None,-1)] += intxCyCInner(0.5*(0.5*ds['W'].isel(Zl=b)**2).data,ds)
    #energy['KE'][-1] += intxCyCInner(0.5*(ds['W'].isel(Zl=-1)**2).data,ds)
    energy[n]['PE'] = intxCyCInner(g*(4e-4*(dss[n]['T']-dss[n]['T0']))**2/2./N0**2,dss[n])

print('Done KE')


# In[36]:

ds=dss[1]
# Body force: v*f*U0
f0=1e-4
b = ds['V'].isel(Yp1=slice(1,None))*f0*U0

energy[1]['Bf'] =   0.5*intxCyCInner(ds['V'].isel(Yp1=slice(1,None)).data*f0*U0,ds)
energy[1]['Bf'] +=   0.5*intxCyCInner(ds['V'].isel(Yp1=slice(0,-1)).data*f0*U0,ds)


# In[37]:

# upW
hf = ds['HFacC'].isel(X=0)+ds['HFacC'].isel(X=1)
p = (ds['PH'].isel(X=0)*ds['HFacC'].isel(X=0)+ds['PH'].isel(X=1)*ds['HFacC'].isel(X=1))/hf
up = p*ds['U'].isel(Xp1=1)
energy[1]['upW']= 0.*dss[n]['T0']
energy[1]['upW'] = (up[:,1:-1]*up['dyG'][1:-1]).sum(dim='Y')

# upE
hf = ds['HFacC'].isel(X=-1)+ds['HFacC'].isel(X=-2)
p = (ds['PH'].isel(X=-1)*ds['HFacC'].isel(X=-1)+ds['PH'].isel(X=-2)*ds['HFacC'].isel(X=-2))/hf
up = p*ds['U'].isel(Xp1=-2)
energy[1]['upE']= 0.*dss[n]['T0']
energy[1]['upE'].data = (-(up*up['dyG'].isel(Y=slice(1,-1))).sum(dim='Y')).data

# vpS
hf = ds['HFacC'].isel(Y=0)+ds['HFacC'].isel(Y=1)
p = (ds['PH'].isel(Y=0)*ds['HFacC'].isel(Y=0)+ds['PH'].isel(Y=1)*ds['HFacC'].isel(Y=1))/hf
up = p*ds['V'].isel(Yp1=1)
energy[1]['vpS']= 0.*dss[n]['T0']
energy[1]['vpS'].data = ((up*up['dxG'].isel(X=slice(1,-1))).sum(dim='X')).data

# vpN
hf = ds['HFacC'].isel(Y=-1)+ds['HFacC'].isel(Y=-2)
p = (ds['PH'].isel(Y=-1)*ds['HFacC'].isel(Y=-1)+ds['PH'].isel(Y=-2)*ds['HFacC'].isel(Y=-2))/hf
up = p*ds['V'].isel(Yp1=-2)
energy[1]['vpN']= 0.*dss[n]['T0']
energy[1]['vpN'].data = (-(up*up['dxG'].isel(X=slice(1,-1))).sum(dim='X')).data




# In[38]:

# uEW

# evaluated on u_1...
E = 0.5*ds['U'].isel(Xp1=1,Y=slice(1,-1))**2
# grr, V is from four surrounding cells to do it right:
dz = ds['HFacS'].isel(X=0,Yp1=slice(1,-2)).data
Ev = 0.5*0.25*ds['V'].isel(X=0,Yp1=slice(1,-2)).data**2 * ds['HFacS'].isel(X=0,Yp1=slice(1,-2)).data
dz+= ds['HFacS'].isel(X=0,Yp1=slice(2,-1)).data
Ev += 0.5*0.25*ds['V'].isel(X=0,Yp1=slice(2,-1)).data**2 * ds['HFacS'].isel(X=0,Yp1=slice(2,-1)).data
dz+= ds['HFacS'].isel(X=1,Yp1=slice(1,-2)).data
Ev += 0.5*0.25*ds['V'].isel(X=1,Yp1=slice(1,-2)).data**2 * ds['HFacS'].isel(X=1,Yp1=slice(1,-2)).data
dz+= ds['HFacS'].isel(X=1,Yp1=slice(2,-1)).data
Ev += 0.5*0.25*ds['V'].isel(X=1,Yp1=slice(2,-1)).data**2 * ds['HFacS'].isel(X=1,Yp1=slice(2,-1)).data
E += Ev/dz
# Hmmm, W?  Lets just leave it out...
# Lienar APE?
dz = ds['HFacC'].isel(X=0,Y=slice(1,-1))
PE = 0.5*0.5*g*(4.e-4*(ds['T'].isel(X=0,Y=slice(1,-1))-ds['T0']))**2/N0**2*ds['HFacC'].isel(X=0,Y=slice(1,-1))
dz += ds['HFacC'].isel(X=1,Y=slice(1,-1))
PE += 0.5*0.5*g*(4.e-4*(ds['T'].isel(X=1,Y=slice(1,-1))-ds['T0']))**2/N0**2*ds['HFacC'].isel(X=1,Y=slice(1,-1))
#E += PE
# OK, E on U grid point.  
energy[1]['ueW'] = (E*ds['U'].isel(Xp1=1,Y=slice(1,-1))*ds['dyG'].isel(Xp1=1,Y=slice(1,-1))).sum(dim='Y')

# uEE

# evaluated on u_1...
E = 0.5*ds['U'].isel(Xp1=-2,Y=slice(1,-1))**2
# grr, V is from four surrounding cells to do it right:
dz = ds['HFacS'].isel(X=-1,Yp1=slice(1,-2)).data
Ev = 0.5*0.25*ds['V'].isel(X=-1,Yp1=slice(1,-2)).data**2 * ds['HFacS'].isel(X=-1,Yp1=slice(1,-2)).data
dz+= ds['HFacS'].isel(X=-1,Yp1=slice(2,-1)).data
Ev += 0.5*0.25*ds['V'].isel(X=-1,Yp1=slice(2,-1)).data**2 * ds['HFacS'].isel(X=-1,Yp1=slice(2,-1)).data
dz+= ds['HFacS'].isel(X=-2,Yp1=slice(1,-2)).data
Ev += 0.5*0.25*ds['V'].isel(X=-2,Yp1=slice(1,-2)).data**2 * ds['HFacS'].isel(X=-2,Yp1=slice(1,-2)).data
dz+= ds['HFacS'].isel(X=-2,Yp1=slice(2,-1)).data
Ev += 0.5*0.25*ds['V'].isel(X=-2,Yp1=slice(2,-1)).data**2 * ds['HFacS'].isel(X=-2,Yp1=slice(2,-1)).data
E += Ev/dz
# Hmmm, W?  Lets just leave it out...
# Lienar APE?
dz = ds['HFacC'].isel(X=-1,Y=slice(1,-1))
PE = 0.5*0.5*g*(4.e-4*(ds['T'].isel(X=-1,Y=slice(1,-1))-ds['T0']))**2/N0**2*ds['HFacC'].isel(X=-1,Y=slice(1,-1))
dz += ds['HFacC'].isel(X=-2,Y=slice(1,-1))
PE += 0.5*0.5*g*(4.e-4*(ds['T'].isel(X=-2,Y=slice(1,-1))-ds['T0']))**2/N0**2*ds['HFacC'].isel(X=-2,Y=slice(1,-1))
#E += PE
# OK, E on U grid point.  
energy[1]['ueE']=0.*energy[1]['ueW']
energy[1]['ueE'].data = -(E*ds['U'].isel(Xp1=-2,Y=slice(1,-1))*ds['dyG'].isel(Xp1=-2,Y=slice(1,-1))).sum(dim='Y').data



# In[39]:

# vEN
# evaluated on u_1...
E = 0.5*ds['V'].isel(Yp1=-2,X=slice(1,-1))**2

# grr, U is from four surrounding cells to do it right:
dz = ds['HFacW'].isel(Y=-1,Xp1=slice(1,-2)).data
Ev = 0.5*0.25*ds['U'].isel(Y=-1,Xp1=slice(1,-2)).data**2 * ds['HFacW'].isel(Y=-1,Xp1=slice(1,-2)).data
dz+= ds['HFacW'].isel(Y=-1,Xp1=slice(2,-1)).data
Ev += 0.5*0.25*ds['U'].isel(Y=-1,Xp1=slice(2,-1)).data**2 * ds['HFacW'].isel(Y=-1,Xp1=slice(2,-1)).data
dz+= ds['HFacW'].isel(Y=-2,Xp1=slice(1,-2)).data
Ev += 0.5*0.25*ds['U'].isel(Y=-2,Xp1=slice(1,-2)).data**2 * ds['HFacW'].isel(Y=-2,Xp1=slice(1,-2)).data
dz+= ds['HFacW'].isel(Y=-2,Xp1=slice(2,-1)).data
Ev += 0.5*0.25*ds['U'].isel(Y=-2,Xp1=slice(2,-1)).data**2 * ds['HFacW'].isel(Y=-2,Xp1=slice(2,-1)).data
E += Ev/dz
# Hmmm, W?  Lets just leave it out...
# Lienar APE?
dz = ds['HFacC'].isel(Y=-1,X=slice(1,-1))
PE = 0.5*0.5*g*(4.e-4*(ds['T'].isel(Y=-1,X=slice(1,-1))-ds['T0']))**2/N0**2*ds['HFacC'].isel(Y=-1,X=slice(1,-1))
dz += ds['HFacC'].isel(Y=-2,X=slice(1,-1))
PE += 0.5*0.5*g*(4.e-4*(ds['T'].isel(Y=-2,X=slice(1,-1))-ds['T0']))**2/N0**2*ds['HFacC'].isel(Y=-2,X=slice(1,-1))
#E += PE
# OK, E on V grid point.  
energy[1]['veN'] = 0*energy[1]['ueE']
energy[1]['veN'].data = -(E*ds['V'].isel(Yp1=-2,X=slice(1,-1))*ds['dxG'].isel(Yp1=-2,X=slice(1,-1))).sum(dim='X').data


# In[40]:

# vES
# evaluated on u_1...
E = 0.5*ds['V'].isel(Yp1=1,X=slice(1,-1))**2

# grr, U is from four surrounding cells to do it right:
dz = ds['HFacW'].isel(Y=0,Xp1=slice(1,-2)).data
Ev = 0.5*0.25*ds['U'].isel(Y=0,Xp1=slice(1,-2)).data**2 * ds['HFacW'].isel(Y=0,Xp1=slice(1,-2)).data
dz+= ds['HFacW'].isel(Y=0,Xp1=slice(2,-1)).data
Ev += 0.5*0.25*ds['U'].isel(Y=0,Xp1=slice(2,-1)).data**2 * ds['HFacW'].isel(Y=0,Xp1=slice(2,-1)).data
dz+= ds['HFacW'].isel(Y=1,Xp1=slice(1,-2)).data
Ev += 0.5*0.25*ds['U'].isel(Y=1,Xp1=slice(1,-2)).data**2 * ds['HFacW'].isel(Y=1,Xp1=slice(1,-2)).data
dz+= ds['HFacW'].isel(Y=1,Xp1=slice(2,-1)).data
Ev += 0.5*0.25*ds['U'].isel(Y=1,Xp1=slice(2,-1)).data**2 * ds['HFacW'].isel(Y=1,Xp1=slice(2,-1)).data
E += Ev/dz
# Hmmm, W?  Lets just leave it out...
# Lienar APE?
dz = ds['HFacC'].isel(Y=0,X=slice(1,-1))
PE = 0.5*0.5*g*(4.e-4*(ds['T'].isel(Y=0,X=slice(1,-1))-ds['T0']))**2/N0**2*ds['HFacC'].isel(Y=0,X=slice(1,-1))
dz += ds['HFacC'].isel(Y=1,X=slice(1,-1))
PE += 0.5*0.5*g*(4.e-4*(ds['T'].isel(Y=1,X=slice(1,-1))-ds['T0']))**2/N0**2*ds['HFacC'].isel(Y=1,X=slice(1,-1))
#E += PE
# OK, E on V grid point.  
energy[1]['veS'] = 0*energy[1]['veN']
energy[1]['veS'].data = (E*ds['V'].isel(Yp1=1,X=slice(1,-1))*ds['dxG'].isel(Yp1=1,X=slice(1,-1))).sum(dim='X').data


# In[41]:

# WP: vertical energy flux.  Integrate laterally.  Just on insides...

# W is on the top of cells.  PH in middle.  We want at the top of the cell (and zero at bottom)
#P = ds['PH']

P = mapZtoZl(ds,'PH')

WP = intxCyCInner(P*ds['W'],ds,hfac=P['HFacC'])
energy[1]['dWPdz'] = 0.*energy[1]['veS']
#print WP.diff(dim='Z1')
#WP.diff()
energy[1]['dWPdz'].data[:-1] = np.diff(WP)/ds['drF'][:-1]
energy[1]['dWPdz'].data[-1] = WP[-1]/(ds['drF'][-1])



# In[43]:

# get the dissipation.  Thought I'd done this, but...

energy[1]['eps'] = intxCyCInner(ds['KLeps-T'].data,ds)


# In[47]:
name='Energy'+pre+'.pickle'
print('Writing '+name)

pickle.dump(energy,open(name,'w'))


