#!/bin/sh -l
#PBS -m be
#PBS -M jklymak@gmail.com
#PBS -l select=64:ncpus=16:mpiprocs=16
#PBS -l walltime=20:45:00
#PBS -q standard
#PBS -A ONRDC35552400
#PBS -j oe
#PBS -N ${JOBNAME}

# two hours took 1:03.  20 h will take 10.5
#

cd $PBS_O_WORKDIR
echo ${U0}

PARENT=LWRegrid2

top=${PBS_JOBNAME}
results=${WORKDIR}/${PARENT}/
outdir=$results$top

# These should already be copied
#cp data $outdir/_Model/input
#cp eedata $outdir/_Model/input
#cp data.* $outdir/_Model/input
#cp ../build/mitgcmuv $outdir/_Model/build

#printf "Copying to archive"
#rm -rf ../archive/$top
#cp -r $outdir/_Model/ ../archive/$top
#rm -rf ../archive/$top/indata/*

cd $outdir/_Model/input
pwd

# Do the 2-s spinup step for two hours....
ls -al ../build/mitgcmuv
cp ./data00 ./data
printf "Starting: SPINUP: $outdir\n"
mpirun -np 1024 ../build/mitgcmuv > mit.out00

# Do the mainrun....
ls -al ../build/mitgcmuv
cp ./data01 ./data
printf "Starting: MainRun: $outdir\n"
mpirun -np 1024 ../build/mitgcmuv > mit.out01

# Do the last hour....
ls -al ../build/mitgcmuv
cp ./data02 ./data
printf "Starting: Last hour: $outdir\n"
mpirun -np 1024 ../build/mitgcmuv > mit.out02

# These need to be submited separately because they are on different queues.

# make mds file sof last hour
cd $PBS_O_WORKDIR
cd ../python
pwd
MDSJOB=`qsub -v PRE="${top}",ITER=72000,ITEREND=75600,DITER=1800 runmdstonetcdf.sh`

echo "Submited mds"
echo ${MDSJOB}

# now GetSlices:  This will wait for MDSJOB to finish...

cd $PBS_O_WORKDIR
cd ../python
pwd
qsub -v PRE="${top}",ITER=72000 -W depend=afterok:${MDSJOB} runGetSlice.sh

echo "Submited runGetSlice.sh"


# now do energy budget:  This will wait for MDSJOB to finish...

cd $PBS_O_WORKDIR
cd ../python
pwd
qsub -v PRE="${top}",U0="${U0}",ITER=72000,DITER=1800 -W depend=afterok:${MDSJOB} runGetEnergy.sh

echo "Submited getEnergy"

# Now archive
TODO=${PBS_JOBNAME}
cd ${WORKDIR}/${PARENT}
rm -f archive_job
cat > archive_job << END2
#!/bin/bash
#PBS -m be
#PBS -M jklymak@gmail.com
#PBS -l walltime=24:00:00
#PBS -q transfer
#PBS -A ONRDC35552400
#PBS -l select=1:ncpus=1
#PBS -j oe
#PBS -S /bin/bash

echo "Transfer job ${PARENT}/${TODO} Started"
cd ${WORKDIR}/${PARENT}
tar cf ${TODO}_files.tar  ${WORKDIR}/${PARENT}/${TODO}
gzip ${TODO}_files.tar
rsh ${ARCHIVE_HOST} mkdir ${ARCHIVE_HOME}/${PARENT}
rcp ${TODO}_files.tar.gz  ${ARCHIVE_HOST}:${ARCHIVE_HOME}/${PARENT}
rsh ${ARCHIVE_HOST} ls -l  ${ARCHIVE_HOME}/${PARENT}
echo "Transfer job ${PARENT}/${TODO} ended"
END2
#
# Submit the archive job script.
#qsub archive_job
# End of batch job

