import numpy
import numpy as np
import scipy
from numpy import squeeze, shape
from numpy import *
from MITgcmutils import rdmds
import sys, getopt, time
import pickle
from os import mkdir
from os import system
import matplotlib.pyplot as plt
import matplotlib.colors as mcolors

runname='lee3dfull02'
outdir='/scr/jklymak/scratch/'+runname+'/pngs2/'
basep='../results/'+runname+'/'
dn = 240*1
timestd = dn*np.array([42000/dn])
timestd = np.arange(dn,42000*1,dn)

#timestd = [0]

try:
    mkdir(outdir)
except:
    pass

oldfiles=[]

dz = rdmds(basep + '_Model/input/'+'DRF',machineformat='l');
z = squeeze(rdmds(basep + '_Model/input/'+'RC',machineformat='l')[:,0,0]);
zf = rdmds(basep + '_Model/input/'+'RF',machineformat='l');
#T = rdmds(basep + '0*/T',num,machineformat='l',fill_value=numpy.NaN)
#x = rdmds(basep + '0*/XC',machineformat='l',fill_value=numpy.NaN)
xc = squeeze(rdmds(basep + '0*/XC',machineformat='l',fill_value=numpy.NaN)[0,:])
x0 = numpy.mean(xc)
xc=xc-x0

x=xc
yc = squeeze(rdmds(basep + '0*/YC',machineformat='l',fill_value=numpy.NaN)[:,0])
y=yc

nx0=shape(x)[0]
xg = squeeze(rdmds(basep + '0*/XG',machineformat='l',fill_value=numpy.NaN)[0,:])
xg=xg-x0
dxc = squeeze(rdmds(basep + '0*/DXC',machineformat='l',fill_value=numpy.NaN)[0,:])
#dxg = squeeze(rdmds(basep + '0*/DXG',machineformat='l',fill_value=numpy.NaN)[0,:])

N=shape(x)[0]
nx = shape(x)[0]
print nx

x = xc/1000.
y=yc/1000.


#hFacC=rdmds(basep + '0*/hFacC',machineformat='l',fill_value=numpy.NaN)
Dep = rdmds(basep+'0*/Depth',machineformat='l')
#for num in range(72000,86800,400):

ind = 5

reg=(0,nx,127,128)
print reg


for tnum,timeind in enumerate(timestd):
#for timeind in [780]:

    D=dict()
    num=timeind
    D['T'] = squeeze(rdmds(basep + '0*/T',num,region=reg,machineformat='l',fill_value=numpy.NaN))
    D['U'] = squeeze(rdmds(basep + '0*/U',num,region=reg,machineformat='l',fill_value=numpy.NaN))
    D['V'] = squeeze(rdmds(basep + '0*/V',num,region=reg,machineformat='l',fill_value=numpy.NaN))
#    D['W'] = squeeze(rdmds(basep + '0*/W',num,region=reg,machineformat='l',fill_value=numpy.NaN))
    D['Eta'] = squeeze(rdmds(basep + '0*/Eta',num,region=reg,machineformat='l',fill_value=numpy.NaN))
    try:
        D['Eps']=squeeze(rdmds(basep + '0*/KLeps-T',num,region=reg,machineformat='l',fill_value=numpy.NaN))
    except:
        pass
    D['Depth']=Dep[0]
    D['x']=x
    D['y']=y
    D['z']=z
    D['dzc']=dz
    #D['hFacC']=hFacC
    
    D['U']=np.ma.masked_where(D['T']==0,D['U'])
    D['V']=np.ma.masked_where(D['T']==0,D['V'])
    D['Eps']=np.ma.masked_where(D['T']==0,D['Eps'])
    D['T']=np.ma.masked_where(D['T']==0,D['T'])

    fig, ax = plt.subplots(3,1,sharex=True,sharey=True)
    tit=['U-0.1 [m/s]','V [m/s]', r'$\epsilon\  [m^2 s^{-3}]$']

    pcm=ax[0].pcolormesh(D['x'],D['z'],D['U']-0.1,
                      vmin=-0.22,vmax=0.22,rasterized=True,cmap='RdBu_r')
    Tc = np.arange(20,29,0.1)
    ax[0].contour(D['x'],D['z'],D['T'],Tc,colors='0.5',linewidth=0.5)
    fig.colorbar(pcm,ax=ax[0],extend='both',shrink=0.7,ticks=np.arange(-.25,.251,0.1))

    pcm=ax[1].pcolormesh(D['x'],D['z'],D['V'],
                      vmin=-0.22,vmax=0.22,rasterized=True,cmap='RdBu_r')
    ax[1].contour(D['x'],D['z'],D['T'],Tc,colors='0.5',linewidth=0.5)
    fig.colorbar(pcm,ax=ax[1],extend='both',shrink=0.7,ticks=np.arange(-.25,.251,0.1))
    pcm=ax[2].pcolormesh(D['x'],D['z'],D['Eps'],
                      vmin=1.e-10,vmax=1.e-5,rasterized=True,cmap='hot_r',norm =mcolors.LogNorm())
    ax[2].contour(D['x'],D['z'],D['T'],Tc,colors='0.5',linewidth=0.5)
    fig.colorbar(pcm,ax=ax[2],extend='both',shrink=0.7,ticks=10.**np.arange(-10.,-4.5))

    ax[0].set_xlim([-50.,50.])
    ax[0].set_ylim([-4000,-2000.00])
    for nn,a in enumerate(ax):
        a.set_axis_bgcolor('0.5')
        a.set_ylabel('DEPTH [m]')
        a.set_title('%s %1.1f h'%(tit[nn],timeind/dn))
    ax[-1].set_xlabel('X [km]')

    fig.savefig(outdir+'/Snap%06d.png'%tnum)
#    with open(outdir+'Diags%05d.pickle'%timeind,'wb') as f:
#        pickle.dump(D,f)

todir = 'valdez.seos.uvic.ca:leewaves15/'
syscom= 'rsync -av '+outdir+' '+todir+runname+'/pngs/'
print syscom
ret=system(syscom)
print ret


exit()



ind=squeeze(where(abs(x)<=15))
print ind[0]
reg=(ind[0],ind[-1],0,1)
x=x[ind]



diags=['Ebt','uPbt','uEbt','Ebc','uPbc','uEbc','Conv']
nn=0
D=dict()
for diag in diags:
    D[diag] = zeros((370,nx0))

for num in arange(1200,96000+10,1200):
#for num in [72000]:
    try:
        print num
        if 1:
            T = rdmds(basep + '0*/T',num,machineformat='l',region=reg,fill_value=numpy.NaN)
            PH = rdmds(basep + '0*/PH',num,machineformat='l',region=reg,fill_value=numpy.NaN)
            PNH = rdmds(basep + '0*/PNH',num,machineformat='l',region=reg,fill_value=numpy.NaN)
            T=T[:,0,:]
            U = rdmds(basep + '0*/U',num,machineformat='l',region=reg,fill_value=numpy.NaN)
            U=U[:,0,:]
            V = rdmds(basep + '0*/V',num,machineformat='l',region=reg,fill_value=numpy.NaN)
            V=V[:,0,:]
            W = rdmds(basep + '0*/W',num,machineformat='l',region=reg,fill_value=numpy.NaN)
            W=W[:,0,:]
            Eta = rdmds(basep + '0*/Eta',num,machineformat='l',region=reg,fill_value=numpy.NaN)
            savez(outdir+'slice%010d' % num,T=T,U=U,V=V,W=W,Eta=Eta,z=z,x=x,Dep=Dep,hFacC=hFacC,xc=xc,PH=PH,PNH=PNH,dxc=dxc,dz=dz)
        if 1:
            for diag in diags:
                dat=rdmds(basep + '0*/'+diag,num,machineformat='l',fill_value=numpy.NaN)[0]
                D[diag][nn,:]=dat
        nn=nn+1
    except Exception, err:
        sys.stderr.write('ERROR: %s\n' % str(err))
# trim
for diag in diags:
    D[diag]=D[diag][0:nn,:]
# save as a pickle
D['dxc']=dxc
D['xc']=xc
D['xg']=xg

f=open(outdir+'Diags.pickle','wb')
pickle.dump(D,f)
f.close()

