# -*- coding: utf-8 -*-
# In[1]:

#import matplotlib.pyplot as plt
import numpy as np
import cPickle as pickle
#import matplotlib.colors as mcolors
import xarray as xr
import xmitgcm as xm
import sys

if len(sys.argv)>2:
    pre = sys.argv[1]
    U0  = float(sys.argv[2])
else:
    sys.exit('Need to specify the prefix directory')

print pre

dss=[0,0,0]
iters = np.array([-1440,-720,0])+28800
for i in [1]:
    n=i
    dss[i] = xr.open_dataset('../results/'+pre+'/_Model/input/ds%010d.nc'%iters[i],
                          chunks={'Z':1,'Zl':1})
    indy = np.where(np.abs(dss[n]['dyG'][:,0]-100.)<0.001)[0]
    indx = np.where(np.abs(dss[n]['dxG'][0,:]-100.)<0.001)[0]
    #    indx = np.where(np.abs(dss[n]['X']-np.mean(dss[n]['X']))<34e3)[0]
    dss[n]= dss[n].isel(YG=indy,YC=np.hstack((indy[0]-1,indy)),
                        XG=indx,XC=np.hstack((indx[0]-1,indx)))
    
ds=dss[1]    
print(ds['PH'].data)
print(ds['PH'].chunks)
# get the pressure on the Zl points:
ds['PL'] = xr.DataArray(0.5*(ds['PH'][:,1:,:,:].data+ds['PH'][:,:-1,:,:].data),dims=('time','Zl','YC','XC'),
                        coords={'Zl':ds['Zl'][1:].values,'YC':ds['YC'].values,'XC':ds['XC'].values })

print('PL:')
print(ds['PL'])
print(ds['W'])
print(ds['rA'])

print(ds['PL'].chunks)
xx=((ds['PL']*ds['W']*ds['rA']).sum(dim=('YC','XC'))).values
print(np.shape(xx))
print(xx[0,0:10])
print(xx[0,-10:])
sys.exit()

print('W:')
print(ds['W'])
#dsV['Pl'] = dsV['PH']*0.
#print(dsV)
WP = (ds['PL']).sum(dim=('XC'))
print('WP')
print(WP)
aa = WP.values
print(aa)
print(np.shape(aa))
sys.exit()
print( WP.diff(dim='Zl'))
print( ds['drF'][1:-1])

energy[1]['dWPdz'] = 0.*ds['T0']
print(energy[1]['dWPdz'][1:-1])
energy[1]['dWPdz'].data[0] = 0
Wp = WP.values
print(Wp)
print(np.shape(Wp))
energy[1]['dWPdz'].data[1:-1] = WP[1:].diff(dim='Zl').data/ds['drF'].values[1:-1]
energy[1]['dWPdz'].data[-1] = 0

print(energy[1])

# upW: This is on the LHS.  Need PH on the G face...
hf = ds['hFacC'].isel(XC=0)+ds['hFacC'].isel(XC=1)
p = (ds['PH'].isel(XC=0,YC=ia)*ds['hFacC'].isel(XC=0,YC=ia)+ds['PH'].isel(XC=1,YC=ia)*ds['hFacC'].isel(XC=1,YC=ia))/hf
up = p*ds['U'].isel(XG=0,YC=ia)
energy[1]['upW']= 0.*dss[1]['T0']
energy[1]['upW'] = (up*up['dyG'].isel(YC=ia)).sum(dim='YC')


# upE
hf = ds['hFacC'].isel(XC=-2)+ds['hFacC'].isel(XC=-1)
p = (ds['PH'].isel(XC=-2,YC=ia)*ds['hFacC'].isel(XC=-2,YC=ia)+ds['PH'].isel(XC=-1,YC=ia)*ds['hFacC'].isel(XC=-1,YC=ia))/hf
up = p*ds['U'].isel(XG=-1,YC=ia)
energy[1]['upE']= 0.*dss[1]['T0']
energy[1]['upE'] = (up*up['dyG'].isel(YC=ia)).sum(dim='YC')


# vpS
hf = ds['hFacC'].isel(YC=(0,1)).sum(dim='YC')
p = (ds['PH'].isel(YC=(0,1),XC=ia)*ds['hFacC'].isel(YC=(0,1),XC=ia)).sum(dim='YC')/hf
up = p*ds['V'].isel(YG=0,XC=ia)
energy[1]['vpS']= 0.*dss[1]['T0']
energy[1]['vpS'] = ((up*up['dxG'].isel(XC=ia)).sum(dim='XC'))

# vpN
hf = ds['hFacC'].isel(YC=(-2,-1)).sum(dim='YC')
p = (ds['PH'].isel(YC=(-2,-1),XC=ia)*ds['hFacC'].isel(YC=(-2,-1),XC=ia)).sum(dim='YC')/hf
up = p*ds['V'].isel(YG=-1,XC=ia)
energy[1]['vpN']= 0.*dss[1]['T0']
energy[1]['vpN'] = ((up*up['dxG'].isel(XC=ia)).sum(dim='XC'))

# veS: South side non-linear energy flux...
xx = 0 # for the XG variable, this is what we want (U)
xs = (0,1) # for the XC variables, we need to average these two (V)
E = 0.5*ds['V'].isel(YG=xx,XC=ia)**2
# need to average 4 V points around each U:
Ev = 0.5*(ds['U'].isel(YC=xs,XG=a)**2*ds['hFacW'].isel(YC=xs,XG=a)).sum(dim='YC').data
Ev += 0.5*(ds['U'].isel(YC=xs,XG=b)**2*ds['hFacW'].isel(YC=xs,XG=b)).sum(dim='YC').data
dz =  (ds['hFacW'].isel(YC=xs,XG=a)).sum(dim='YC').data
dz += (ds['hFacW'].isel(YC=xs,XG=b)).sum(dim='YC').data
E += Ev/dz
# APE:
PE = (0.5*g*(4.e-4*(ds['T'].isel(YC=xs,XC=ia)-ds['T0']))**2/N0**2*ds['hFacC'].isel(YC=xs,XC=ia)).sum(dim='YC')
E += PE/(ds['hFacC'].isel(YC=xs,XC=ia)).sum(dim='YC')
energy[1]['veS'] = (E*ds['V'].isel(YG=xx,XC=ia)*ds['dxG'].isel(YG=xx,XC=ia)).sum(dim='XC')

print(energy[1])

# veN: North side non-linear energy flux...
xx = -1 # for the XG variable, this is what we want (U)
xs = (-2,-1) # for the XC variables, we need to average these two (V)
E = 0.5*ds['V'].isel(YG=xx,XC=ia)**2
# need to average 4 V points around each U:
Ev = 0.5*(ds['U'].isel(YC=xs,XG=a)**2*ds['hFacW'].isel(YC=xs,XG=a)).sum(dim='YC').data
Ev += 0.5*(ds['U'].isel(YC=xs,XG=b)**2*ds['hFacW'].isel(YC=xs,XG=b)).sum(dim='YC').data
dz =  (ds['hFacW'].isel(YC=xs,XG=a)).sum(dim='YC').data
dz += (ds['hFacW'].isel(YC=xs,XG=b)).sum(dim='YC').data
E += Ev/dz
# APE:
PE = (0.5*g*(4.e-4*(ds['T'].isel(YC=xs,XC=ia)-ds['T0']))**2/N0**2*ds['hFacC'].isel(YC=xs,XC=ia)).sum(dim='YC')
E += PE/(ds['hFacC'].isel(YC=xs,XC=ia)).sum(dim='YC')
energy[1]['veN'] = (E*ds['V'].isel(YG=xx,XC=ia)*ds['dxG'].isel(YG=xx,XC=ia)).sum(dim='XC')


# uEE: West side non-linear energy flux...
xx = -1 # for the XG variable, this is what we want (U)
xs = (-2,-1) # for the XC variables, we need to average these two (V)
E = 0.5*ds['U'].isel(XG=xx,YC=ia)**2
# need to average 4 V points around each U:
Ev = 0.5*(ds['V'].isel(XC=xs,YG=a)**2*ds['hFacS'].isel(XC=xs,YG=a)).sum(dim='XC').data
Ev += 0.5*(ds['V'].isel(XC=xs,YG=b)**2*ds['hFacS'].isel(XC=xs,YG=b)).sum(dim='XC').data
dz =  (ds['hFacS'].isel(XC=xs,YG=a)).sum(dim='XC').data
dz += (ds['hFacS'].isel(XC=xs,YG=b)).sum(dim='XC').data
E += Ev/dz
# APE:
PE = (0.5*g*(4.e-4*(ds['T'].isel(XC=xs,YC=ia)-ds['T0']))**2/N0**2*ds['hFacC'].isel(XC=xs,YC=ia)).sum(dim='XC')
E += PE/(ds['hFacC'].isel(XC=xs,YC=ia)).sum(dim='XC')
energy[1]['ueE'] = (E*ds['U'].isel(XG=xx,YC=ia)*ds['dyG'].isel(XG=xx,YC=ia)).sum(dim='YC')

# uEW: West side non-linear energy flux...
E = 0.5*ds['U'].isel(XG=0,YC=ia)**2
# need to average 4 V points around each U:
Ev = 0.5*(ds['V'].isel(XC=(0,1),YG=a)**2*ds['hFacS'].isel(XC=(0,1),YG=a)).sum(dim='XC').data
Ev += 0.5*(ds['V'].isel(XC=(0,1),YG=b)**2*ds['hFacS'].isel(XC=(0,1),YG=b)).sum(dim='XC').data
dz =  (ds['hFacS'].isel(XC=(0,1),YG=a)).sum(dim='XC').data
dz += (ds['hFacS'].isel(XC=(0,1),YG=b)).sum(dim='XC').data
E += Ev/dz
# APE:
PE = (0.5*g*(4.e-4*(ds['T'].isel(XC=(0,1),YC=ia)-ds['T0']))**2/N0**2*ds['hFacC'].isel(XC=(0,1),YC=ia)).sum(dim='XC')
E += PE/(ds['hFacC'].isel(XC=(0,1),YC=ia)).sum(dim='XC')
energy[1]['ueW'] = (E*ds['U'].isel(XG=0,YC=ia)*ds['dyG'].isel(XG=0,YC=ia)).sum(dim='YC')

print(energy[1])


# get the dissipation.  Thought I'd done this, but...


energy[1]['eps'] = (ds['KLeps']*ds['hFacC'].isel(XC=ia,YC=ia,Z=b)*ds['rA'].isel(XC=ia,YC=ia)).sum(dim=('XC','YC'))



# In[47]:
name='Energy'+pre+'.pickle'
print('Writing '+name)

pickle.dump(energy,open(name,'w'))


