import numpy as np
import xarray as xr
import xmitgcm as xm
from dask.diagnostics import ProgressBar
import time

start = time.clock()
pre = 'regrid3dfull01U10'

iters = np.array([0])+51840
for i in range(len(iters)):
    n=i
    ds = xm.open_mdsdataset('../results/'+pre+'/_Model/input/',iters=[iters[i]], delta_t=5.,endian='<',geometry='cartesian',ignore_unknown_vars=True,
                          chunks={'Z':100,'Zl':100})
    indy = np.where(np.abs(ds['dyG'][:,0]-100.)<0.001)[0]
    indx = np.where(np.abs(ds['dxG'][0,:]-100.)<0.001)[0]
    #    indx = np.where(np.abs(dss[n]['X']-np.mean(dss[n]['X']))<34e3)[0]
    ds = ds.isel(YG=indy,YC=np.hstack((indy[0]-1,indy)),
                        XG=indx,XC=np.hstack((indx[0]-1,indx)))

ia = slice(1,-1) # should be inner data (excluding edges)
a  = slice(None,-1) # should be first to second last
b  = slice(1,None) # should be second to last

## get dWdP term at each depth. 
# get the pressure on the Zl points:
print('Starting d(WP)/dz')
PL = xr.DataArray(0.5*(ds['T'][:,1:,:,:].data+ds['T'][:,:-1,:,:].data),dims=('time','Zl','YC','XC'),
                        coords={'Zl':ds['Zl'][1:].values,'YC':ds['YC'].values,'XC':ds['XC'].values })

with ProgressBar():
    WP=((PL*ds['W']*ds['rA']).sum(dim=('YC','XC'))).values
dWPz = np.hstack((np.zeros((1,1)),np.diff(WP,axis=1)/ds['drF'].values[np.newaxis,1:-1]))
print(dWPz)
print(time.clock()-start, "seconds")
