import numpy as np
import xarray as xr
import xmitgcm as xm
from dask.diagnostics import ProgressBar
import time

start = time.clock()
pre = 'regrid3dfull01U10'
doissel=False
iters = [47520]
ds = xm.open_mdsdataset('../results/'+pre+'/_Model/input/',iters=iters,
                        delta_t=5.,endian='<',geometry='cartesian',ignore_unknown_vars=True,
                        chunks={'Z':100,'Zl':100})
indy = np.where(np.abs(ds['dyG'][:,0]-100.)<0.001)[0]
indx = np.where(np.abs(ds['dxG'][0,:]-100.)<0.001)[0]
#    indx = np.where(np.abs(dss[n]['X']-np.mean(dss[n]['X']))<34e3)[0]
if doissel:
    ds = ds.isel(YG=indy,YC=np.hstack((indy[0]-1,indy)),
                 XG=indx,XC=np.hstack((indx[0]-1,indx)))

ia = slice(1,-1) # should be inner data (excluding edges)
a  = slice(None,-1) # should be first to second last
b  = slice(1,None) # should be second to last

## get dWdP term at each depth. 
# get the pressure on the Zl points:

test_calc = (ds.PH*ds.S).sum(dim=('YC','XC'))
aa = test_calc.compute()

print(time.clock()-start, "seconds")
